import random

def roll( num: int = 1, sides: int = 6) -> list:
    '''
    Produces a list of results from rolling a dice a number of times

    Paramaters
    ----------
    num: int
        The number of times the dice will be rolled (Default is 1)
    sides: int
        The number of sides the dice has (Default is 6)
    '''

    results: list = []
    [results.append(random.randint(1, sides)) for _ in range(1, sides)]
    return results

# end roll


def filter_eq(results: list, qualifier: int) -> list:
    '''
    Filters the results from a dice roll that are equal to a certain value

    Parameters
    ----------
    results: list, required
        The results of a dice roll, usually generated by the roll function
    qualifier: int
        The value the rolls are compaired against
    '''

    filtered_results: list = []
    [filtered_results.append(i) for i in results if qualifier == i]
    return filtered_results

# end filter_eq


def filter_gt(results: list, qualifier: int) -> list:
    '''
    Filters the results from a dice roll that are greater a certain value

    Parameters
    ----------
    results: list, required
        The results of a dice roll, usually generated by the roll function
    qualifier: int
        The value the rolls are compaired against
    '''

    filtered_results: list = []
    [filtered_results.append(i) for i in results if qualifier < i]
    return filtered_results

# end filter_gt


def filter_gt_or_eq( results: list, qualifier: int ) -> list:
    '''
    filters the results from a dice roll that are greater than or equal to a certain value

    parameters
    ----------
    results: list, required
        the results of a dice roll, usually generated by the roll function
    qualifier: int
        the value the rolls are compaired against
    '''

    filtered_results: list = []
    [filtered_results.append(i) for i in results if qualifier <= i]
    return filtered_results

# end filter_gt_or_eq


def filter_lt(results: list, qualifier: int) -> list:
    '''
    Filters the results from a dice roll that are less than a certain value

    Parameters
    ----------
    results: list, required
        The results of a dice roll, usually generated by the roll function
    qualifier: int
        The value the rolls are compaired against
    '''

    filtered_results: list = []
    [filtered_results.append(i) for i in results if i < qualifier]
    return filtered_results

# end filter_lt


def filter_lt_or_eq( results: list, qualifier: int ) -> list:
    '''
    Filters the results from a dice roll that are less than or equal to a certain value

    Parameters
    ----------
    results: list, required
        The results of a dice roll, usually generated by the roll function
    qualifier: int
        The value the rolls are compaired against
    '''

    filtered_results: list = []
    [filtered_results.append(i) for i in results if i <= qualifier]
    return filtered_results

# end filter_lt_or_eq
